#!/usr/bin/php
<?php
/**
 * This script imports comments from zone files and adds them to records and domains (unless they are not in the DB)
 * @package ZoneAdmin
 * @author Daniel Weuthen
 * @version 0.1
 * @copyright Daniel Weuthen
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License
 */

include('../includes/defaults.php');
include("../includes/config.php");

$filename = $argv[1];
$domain = basename($filename);

$lines = file($filename);

$domain_id = get_id_from_domain($domain);

if($domain_id > 0) {
  for ($lc = 0; $lc < count($lines); $lc++) {
    $comment = "";
    $comment_found = FALSE;

    # if a record is found check if above line is a comment, if above line is a commented out record 
    # stop searching for further parts of the comment
//    if ( preg_match('/^([A-Za-z0-9].+)IN.+(A|AAAA|NS|MX|TXT|CNAME).+$/i',$lines[$lc],$hit) ) {
    if ( preg_match('/^([A-Za-z0-9-\.]*)\s+IN\s+([A-Z]{1,5})(\s+[0-9]+\s+|\s+)([a-z0-9-\.]+)\s*$/i',$lines[$lc], $hit) ) {
      $lines_backward = 1;
      while (preg_match('/^;(.+)/',$lines[$lc-$lines_backward], $hit_comment)) {
//        if ( preg_match('/^([A-Za-z0-9].+)IN.+(A|AAAA|NS|MX|TXT|CNAME).+$/i',$hit_comment[1]) ) {
          if ( preg_match('/^([A-Za-z0-9-\.]*)\s+IN\s+([A-Z]{1,5})(\s+[0-9]+\s+|\s+)([a-z0-9-\.]+)\s*\;(.+)$/i',$hit_comment[1]) ) {
          break;  
        }   
        $lines_backward++;
        $comment .= trim($hit_comment[1])."\n";
      }
      $comment_found = TRUE;

      $content = trim($hit[4]);
      if(substr($content,-1) == ".") $content = substr($content,0,-1);
      $type = trim($hit[2]);
      $comment_found = TRUE;
      $hostname = trim($hit[1]);
      if(!empty($hostname)) $hostname = $hostname.".";

    } 

    # if comment in same line with record 
    if ( preg_match('/^([A-Za-z0-9-\.]*)\s+IN\s+([A-Z]{1,5})(\s+[0-9]+\s+|\s+)([a-z0-9-\.]+)\s*\;(.+)$/i',$lines[$lc], $hit) ) 
    {
      $comment .= trim($hit[5]);
      $content = trim($hit[4]);
      if(substr($content,-1) == ".") $content = substr($content,0,-1);
      $type = trim($hit[2]);
      $comment_found = TRUE;
      $hostname = trim($hit[1]);
      if(!empty($hostname)) $hostname = $hostname.".";
//      print_r($hit);
    }


    if ($comment_found == TRUE ) {
      $record_id = get_id_from_record($hostname.$domain);
      if($record_id == 0) {
        $record_id = get_id_from_record($hostname.$domain,$type,$content);
      }
      echo "$record_id $domain_id $hostname$domain $comment\n";
      if($record_id > 0) {
        add_comment($domain_id,$record_id,"admin","$comment");
      }
    }  
  }

  # add whole file as comment to zone
  if(!comment_exists($domain_id,0)) add_comment($domain_id,0,"admin",implode("",$lines));
}
