/* General Style functions */

function setBgColor(element,color) {
  var el = document.getElementById(element);
  el.style.background = color;
}

/* Safety Checks and Input Validation */

function checkDelete(element) {
  return confirm('Soll '+element+' wirklich geloescht werden?')
}

var fields = Array();


/* structure of nameRegex 
 * regular record-name/empty record-name | _domainkey record | *._domainkey record | wildcard record
 *
 */
var nameRegex = /^(([a-z0-9\.-]*)|((_domainkey)[a-z0-9\.-]*)|([a-z0-9\.-]+(\._domainkey)[a-z0-9\.-]*)|(\*([a-z0-9\.-]*)))$/i
var prioRegex = /^\d+$/;
var ttlRegex = /^\d+$/;
var contentRegex = Array();

contentRegex['A'] = /^([0-9]{1,3}\.){3}[0-9]{1,3}$/i;
contentRegex['AAAA'] = /^[0-9a-f:]+$/i;
contentRegex['SOA'] = /^[a-z0-9\.\-]+ [a-z0-9\.\-]+ [0-9]+ [0-9]+ [0-9]+ [0-9]+ [0-9]+$/i;
contentRegex['MX'] = /^[0-9a-z\.-]+$/i;
contentRegex['NS'] = /^[0-9a-z\.-]+$/i;
contentRegex['CNAME'] = /^[0-9a-z\.-]+$/i;
contentRegex['TXT'] = /^.+/i;
contentRegex['PTR'] = /^[0-9a-z\.-]+$/i;

function updateType(type,title) {
  changeVerifyRegex(title,contentRegex[type]);
}

function addverify(element,title,regex) {
  fields.push(Array(element,title,regex));
}

function changeVerifyRegex(title,regex) {
  for (var i in fields) {
    if (fields[i][1] == title) {
      fields[i][2] = regex;
      break;
    }
  }
}

function verifyinput() {
  var error = Array();
  var msg = '';

  for (var i = 0; i < fields.length; i++) {
    if(fields[i][2].exec(fields[i][0].value) == null) {
      error.push(fields[i][1]);
      fields[i][0].style.border = 'solid 1px #DD0000'
    }
    else {
      fields[i][0].style.border = 'solid 1px #000000'
    }
  }
  if (error.length > 0) {
    var errdiv = document.getElementById('errordiv');
    for(var i = 0; i < error.length; i++) {
      msg = msg+'Missing or invalid input in field \'<i>'+error[i]+'</i>\'<br />';
    }
    errdiv.innerHTML = msg;
    errdiv.style.display = 'block';
    return false;
  }
  else {
    var errdiv = document.getElementById('errordiv');
    errdiv.style.display = 'none';
    return true;
  }
}

/* Show/Hide Elements */

//either show or hide the zone-comment 
function toggleComments() {
  var el = document.getElementById('comments');
  var gfx = document.getElementById('arrow');
  if (el.style.display == 'none') {
    el.style.display = 'block';
    gfx.src = 'img/down.png';
  }
  else {
    el.style.display = 'none';
    gfx.src = 'img/right.png';
  }
}

//either show or hide the history-layer
function toggleHistory() {
  var el = document.getElementById('history');
  var gfx = document.getElementById('history_arrow');
  if (el.style.display == 'none') {
    el.style.display = 'block';
    gfx.src = 'img/down.png';
  }
  else {
    el.style.display = 'none';
    gfx.src = 'img/right.png';
  }
}

//determine the position of a given element
function getPosition(element) {
  var elem=element,tagname="",x=0,y=0;
  
  while ((typeof(elem)=="object")&&(typeof(elem.tagName)!="undefined"))
  {
    y+=elem.offsetTop; 
    x+=elem.offsetLeft;
    tagname=elem.tagName.toUpperCase();

    if (tagname=="BODY")
      elem=0;

    if (typeof(elem)=="object")
      if (typeof(elem.offsetParent)=="object")
        elem=elem.offsetParent;
  }

  position=new Object();
  position.x=x;
  position.y=y;
  return position;
}

//display the comment-layer at the position from where the OnMouseOver event was fired
function showComment(caller,user,comment) {
  var cmt = document.getElementById('recordComment');
  cmt.style.position = 'absolute';
  cmt.style.visibility = 'visible';
  cmt.innerHTML = '<b><u>Kommentar von '+user+'</u></b>:<br />'+comment+'<br /><br />';

  cmt.style.width = 400;

  cmt.style.zIndex = 50;
  var pos = getPosition(caller);
  cmt.style.left = pos.x - 400;
  cmt.style.top = pos.y;
}

//hide the comment-layer (see previous function)
function hideComment() {
  var cmt = document.getElementById('recordComment');
  cmt.style.visibility = 'hidden';
}

/* Other functions */

// used in editsoa template
function multiply(amount) {
  var num = document.soa.zahl.value;
  num = num * amount;
  document.soa.zahl.value = num;
}
